<template>
	<div>
		<MoleculeCarousel
			v-if="items"
			ref="video-carousel"
			:autoplay="false"
			:initial-slide="initialSlide"
			:has-pagination="false"
			:has-tab-navigation="true"
			:tab-items="items"
			:has-navigation="false"
			@slidechanged="handleSlideChanged"
		>
			<MoleculeCarouselSlide v-for="(product, index) in items" :key="index" :slide-index="index">
				<div v-if="product.ctaLink && product.ctaLink.url" :class="$style.buttonWrapper">
					<BaseButtonArrow :smart="product.ctaLink.url">
						{{ product.ctaCopy }}
					</BaseButtonArrow>
				</div>
				<BlockVideo
					ref="video"
					:is-loop="false"
					:heading="product.heading || ''"
					:heading-desktop="product.headingDesktop || ''"
					:heading-desktop-animated="product.headingDesktopAnimated"
					:heading-fade-out-enabled="product.headingFadeOutEnabled"
					:heading-fade-out-delay="product.headingFadeOutDelay || 3000"
					:heading-color="product.headingColor"
					:copy-color="product.copyColor"
					:heading-color-desktop="product.headingColorDesktop"
					:copy-color-desktop="product.copyColorDesktop"
					:description="product.description"
					:video-background-mobile="product.videoBackgroundMobile"
					:video-background="product.videoBackground"
					:video-aspect-ratio-mobile="product.videoAspectRatioMobile"
					:video-aspect-ratio-desktop="product.videoAspectRatioDesktop"
					@video-ended="handleVideoEnded"
				/>
			</MoleculeCarouselSlide>
		</MoleculeCarousel>
	</div>
</template>

<script>
import MoleculeCarousel from '@components/molecule-carousel';
import MoleculeCarouselSlide from '@components/molecule-carousel-slide';
import BlockVideo from '@components/block-video';

export default {
	components: {
		MoleculeCarousel,
		MoleculeCarouselSlide,
		BlockVideo,
	},
	props: {
		items: {
			type: Array,
			required: true,
		},
		initialSlide: {
			type: Number,
			default: 0,
		},
	},

	data: () => ({ currentSlide: 0 }),

	methods: {
		handleSlideChanged(currentIndex) {
			this.currentSlide = currentIndex;
			this.pauseAndRewindAllVideos();
			this.$refs.video[currentIndex].$refs.video.play();
		},

		handleVideoEnded(e) {
			this.pauseAndRewindAllVideos();
			this.$refs[`video-carousel`].switchSlide(this.currentSlide + 1);
		},

		pauseAndRewindAllVideos() {
			for (let i = 0; i < this.items.length; i++) {
				this.$refs.video[i].$refs.video.currentTime = 0;
				this.$refs.video[i].$refs.video.pause();
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.buttonWrapper {
	position: absolute;
	top: auto;
	right: 0;
	bottom: 2rem;
	left: 0;
	z-index: 1;
	display: flex;
	justify-content: center;

	@include above('medium') {
		top: 13rem;
		right: auto;
		bottom: auto;
		left: 6.5rem;
	}
}
</style>
